#!/bin/bash

## Crea usuaris d'escriptoris remots.

LOG="/var/log/linkat-er.log"
PREFIX=""
NUM_USERS=""
MULTIUSER=""
DIR_USERS="/usr/share/linkat/linkat-escriptoris-remots/multi-users"
if [ ! -d "$DIR_USERS" ]; then
  mkdir -m 750 -p "$DIR_USERS" 
fi

function create_multiuser_er {
  useradd -m "$MULTIUSER" -s /bin/bash
  if [ ! $? -eq 0 ]; then
	echo -en "L'usuari $MULTIUSER ja existeix o no es pot afegir.\n" >> $LOG
  else
  	echo -e "$MULTIUSER\n$MULTIUSER\n" | passwd "$MULTIUSER"
  fi
  }

function create_guac_user {
  cat /usr/share/linkat/linkat-escriptoris-remots/user-map | \
    sed 's/__USER__/'"$MULTIUSER"'/g' | \
    sed 's/__PASS__/'"$MULTIUSER"'/g' > $DIR_USERS/user-map-$MULTIUSER.xml
  sed -i 's/<\/user-mapping>//g'  /etc/guacamole/user-mapping.xml
  cat $DIR_USERS/user-map-$MULTIUSER.xml >> /etc/guacamole/user-mapping.xml
}

res=$(zenity --title="Linkat Escriptoris Remots" --text="Afegeix usuaris genèrics:" --forms --add-entry="Prefix del nom" --add-entry="Nombre d'usuaris")
        if [ ! $? -eq 0 ];then
                exit 2
        fi
PREFIX=$(echo "$res" | awk -F"|" '{print $1}')
NUM_USERS=$(echo "$res" | awk -F"|" '{print $2}')


for i in `seq 1 $NUM_USERS` ; do
  MULTIUSER=$PREFIX$i
  create_multiuser_er
  create_guac_user
done

zenity --info --title="Linkat Escriptoris Remots" --width=250 --text="Usuaris afegits correctament"
