#!/bin/bash

## Crea usuaris d'escriptoris remots.

LOG="/var/log/linkat-er.log"
USER_ER=""
PASS_ER1=""
PASS_ER2=""
DIR_USERS="/usr/share/linkat/linkat-escriptoris-remots/users"
if [ ! -d "$DIR_USERS" ]; then
  mkdir -m 750 -p "$DIR_USERS"
fi

function create_user_er {
  useradd -m "$USER_ER" -s /bin/bash
  if [ ! $? -eq 0 ]; then
        echo -en "L'usuari $USER_ER ja existeix o no es pot afegir.\n" >> $LOG
  else
	echo -e "$PASS_ER1\n$PASS_ER1\n" | passwd "$USER_ER"
  fi
  }

function create_guac_user {
  cat /usr/share/linkat/linkat-escriptoris-remots/user-map | \
    sed 's/__USER__/'"$USER_ER"'/g' | \
    sed 's/__PASS__/'"$PASS_ER1"'/g' > $DIR_USERS/user-map-$USER_ER.xml
  sed -i 's/<\/user-mapping>//g'  /etc/guacamole/user-mapping.xml
  cat $DIR_USERS/user-map-$USER_ER.xml >> /etc/guacamole/user-mapping.xml
}

MES="0"
MALPASS="0"
MALUSER="0"
while [ $MES -eq 0 ]; do
   while [[ "$MALUSER" -eq 0 || "$MALPASS" -eq 0 ]]; do
	res=$(zenity --title="Linkat Escriptoris Remots" --text="Afegeix usuari:" --forms --add-entry="Nom d'usuari" --add-password="Contrasenya" --add-password="Repeteix contrasenya")
	if [ ! $? -eq 0 ];then
		exit 2
	fi
	USER_ER=$(echo "$res" | awk -F"|" '{print $1}')
	PASS_ER1=$(echo "$res" | awk -F"|" '{print $2}')
	PASS_ER2=$(echo "$res" | awk -F"|" '{print $3}')

	grep "^"$USER_ER":" /etc/passwd 
	if [ $? -eq 0 ]; then
		zenity --error --width=200 --text="L'usuari ja existeix, introduiex un altre nom d'usuari."
		MALUSER="0"
	else
		MALUSER="1"
	fi

	if [ ! "$PASS_ER1" == "$PASS_ER2" ]; then
    		zenity --error --width=200 --text="Les contrasenyes no coincideixen. Torna a crear l'usuari."
    		MALPASS="0"
	else
		MALPASS="1"
	fi
   done
	create_user_er
	create_guac_user
	zenity --info --width=200 --title="Linkat Escriptoris Remots" --text="Usuari afegit correctament"

zenity --question --width=200 --title="Linkat Escriptoris Remots" --text="Voleu afegir més usuaris?"
if [ ! $? -eq 0 ]; then
        MES=1
fi

done
